VehicleFruitHud = {};
VehicleFruitHud.metadata = {
	interface = " FS19 ...",
	title = " VehicleFruit Hud",
	notes = " setzt Name/Prozent/Kapazität zusätzlich ins VehicleFruit Hud und ändert Schema",
	author = " (by HappyLooser)",
	version = " v0.3",	
	datum = " 20.11.2018",
	update = " 28.11.2018",
	web = " no",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe:"
};


function VehicleFruitHud:loadMap(name)
	if g_currentMission.vehicleFruitHud == nil then g_currentMission.vehicleFruitHud = true;end;
	print("---loading".. tostring(VehicleFruitHud.metadata.title).. tostring(VehicleFruitHud.metadata.version).. tostring(VehicleFruitHud.metadata.author).. "---")
	VehicleFruitHud.color = {255/255, 255/255,   0/255, 1.00};
	VehicleFruitHud.prozent = true;
	VehicleFruitHud.capacity = true;
	VehicleFruitHud.name = true;
	VehicleFruitHud.namePos = 2;
	VehicleFruitHud.schemaPos = 1;
	VehicleFruitHud.schemaZoom = 1.0;
	VehicleFruitHud.schemaFixY = 0.0
	VehicleFruitHud.settingsDir = getUserProfileAppPath().. "modsSettings/VehicleFruitHud/";
	if g_server ~= nil and g_client == nil then return;end;
	VehicleFruitHud:setGetCfg(true);
end;

function VehicleFruitHud:deleteMap()
	VehicleFruitHud:setGetCfg(false);	
end;

function VehicleFruitHud:mouseEvent(posX, posY, isDown, isUp, button)
end;

function VehicleFruitHud:keyEvent(unicode, sym, modifier, isDown)	
end;

function VehicleFruitHud:update(dt)
end;

function VehicleFruitHud:draw(dt)
	if g_server ~= nil and g_client == nil then return;end;
	if g_currentMission.hud.fillLevelsDisplay.vehicle ~= nil and g_currentMission.hud.showVehicleSchema then		
		setTextColor(unpack(VehicleFruitHud.color));
		setTextBold(true);
		if g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer ~= nil and type(g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer) == "table" and #g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer > 0 then
			local frameHeight = g_currentMission.hud.fillLevelsDisplay.frameHeight;
			for a=1, #g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer do
				if g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer[a] ~= nil then					
					local capacity = g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer[a].capacity or 0;
					local fillType = g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer[a].fillType or 0;
					local fillLevel = g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer[a].fillLevel or 0;
					local percent = VehicleFruitHud:getProzentString(fillLevel, capacity);
					--local descFruit = g_currentMission.fruitTypeManager.fruitTypes[fillType]; --later fruitTypeIndexToFillType a test convertFruitViaFill
					local descFill = g_currentMission.fillTypeManager.fillTypes[fillType];
					if descFruit ~= nil and descFill ~= nil then 
						--if descFruit ~= descFill then descFill = descFruit;end;
					end;
					if descFill ~= nil then						
						local name = descFill.title or descFill.name;
						local txtHeight = getTextHeight(g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, tostring("Gg"));
						if capacity > 0 then 
							setTextAlignment(2);
							if VehicleFruitHud.capacity then renderText(g_currentMission.hud.fillLevelsDisplay.origX+g_currentMission.hud.fillLevelsDisplay.overlay.width, g_currentMission.hud.fillLevelsDisplay.origY+(frameHeight*(a-1))-txtHeight, g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, tostring(capacity));end;
						
							if fillLevel > 0 then 
								setTextAlignment(0);
								if VehicleFruitHud.prozent then renderText(g_currentMission.hud.fillLevelsDisplay.origX+(g_currentMission.hud.fillLevelsDisplay.overlay.width/5), g_currentMission.hud.fillLevelsDisplay.origY+(frameHeight*(a-1))-txtHeight, g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, tostring(percent).. "%");end;
							end;
						end;
						if not string.find(name, "Unknown") then							
							if VehicleFruitHud.namePos == 1 then
								setTextAlignment(2);
								renderText(g_currentMission.hud.fillLevelsDisplay.origX, g_currentMission.hud.fillLevelsDisplay.origY+(frameHeight*(a-1)), g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, tostring(name));
							elseif VehicleFruitHud.namePos == 2 then
								local optiSize = VehicleFruitHud:getOptimalSize(g_currentMission.hud.fillLevelsDisplay.overlay.width-getTextWidth(g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, tostring(name)), tostring(name), g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize)
								setTextAlignment(0);
								renderText(g_currentMission.hud.fillLevelsDisplay.origX+(g_currentMission.hud.fillLevelsDisplay.overlay.width/5), g_currentMission.hud.fillLevelsDisplay.origY+(frameHeight*(a-1))+txtHeight*1.5, optiSize, tostring(name));
							end;
						end;
					end;
				end;
			end;
		end;
		--respect settings for other mods
		setTextAlignment(0);
		setTextColor(1, 1, 1, 1);
		setTextBold(false);
		--respect settings for other mods
	end;
end;
addModEventListener(VehicleFruitHud);

function VehicleFruitHud:getProzentString(fill, capacity)	
	return string.format("%1.0f", "".. tonumber(fill)/tonumber(capacity)*100);
end;

function VehicleFruitHud:setGetCfg(loadCfg)
	createFolder(getUserProfileAppPath().. "modsSettings/");
	createFolder(VehicleFruitHud.settingsDir);
	local file = VehicleFruitHud.settingsDir.. "vehicleFruitHudSettings.xml";
	local Xml = nil;
	if not fileExists(file) or not loadCfg then
		Xml = createXMLFile("VehicleFruitHud_XML", file, "vehicleFruitHudSettings");
		local groupNameTag = ("vehicleFruitHudSettings.global(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#prozent", VehicleFruitHud.prozent);
		setXMLBool(Xml, groupNameTag.. "#capacity", VehicleFruitHud.capacity);
		setXMLBool(Xml, groupNameTag.. "#name", VehicleFruitHud.name);
		setXMLInt(Xml, groupNameTag.. "#namePos", VehicleFruitHud.namePos);
		setXMLFloat(Xml, groupNameTag.. "#colorR", VehicleFruitHud.color[1]);
		setXMLFloat(Xml, groupNameTag.. "#colorG", VehicleFruitHud.color[2]);
		setXMLFloat(Xml, groupNameTag.. "#colorB", VehicleFruitHud.color[3]);
		setXMLFloat(Xml, groupNameTag.. "#colorA", VehicleFruitHud.color[4]);
		setXMLFloat(Xml, groupNameTag.. "#schemaZoom", VehicleFruitHud.schemaZoom);
		setXMLFloat(Xml, groupNameTag.. "#schemaFixY", VehicleFruitHud.schemaFixY);
		setXMLInt(Xml, groupNameTag.. "#schemaPos", VehicleFruitHud.schemaPos);
		saveXMLFile(Xml);
	else	
		Xml = loadXMLFile("VehicleFruitHud_XML", file, "vehicleFruitHudSettings");
		local groupNameTag = ("vehicleFruitHudSettings.global(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#prozent") ~= nil then VehicleFruitHud.prozent = getXMLBool(Xml, groupNameTag.. "#prozent");end;
		if getXMLBool(Xml, groupNameTag.. "#capacity") ~= nil then VehicleFruitHud.capacity = getXMLBool(Xml, groupNameTag.. "#capacity");end;
		if getXMLBool(Xml, groupNameTag.. "#name") ~= nil then VehicleFruitHud.name = getXMLBool(Xml, groupNameTag.. "#name");end;
		if getXMLInt(Xml, groupNameTag.. "#namePos") then VehicleFruitHud.namePos = getXMLInt(Xml, groupNameTag.. "#namePos");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorR") then VehicleFruitHud.color[1] = getXMLFloat(Xml, groupNameTag.. "#colorR");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorG") then VehicleFruitHud.color[2] = getXMLFloat(Xml, groupNameTag.. "#colorG");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorB") then VehicleFruitHud.color[3] = getXMLFloat(Xml, groupNameTag.. "#colorB");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorA") then VehicleFruitHud.color[4] = getXMLFloat(Xml, groupNameTag.. "#colorA");end;
		if getXMLInt(Xml, groupNameTag.. "#schemaPos") then VehicleFruitHud.schemaPos = getXMLInt(Xml, groupNameTag.. "#schemaPos");end;
		if getXMLFloat(Xml, groupNameTag.. "#schemaZoom") then VehicleFruitHud.schemaZoom = getXMLFloat(Xml, groupNameTag.. "#schemaZoom");end;	
		if getXMLFloat(Xml, groupNameTag.. "#schemaFixY") then VehicleFruitHud.schemaFixY = getXMLFloat(Xml, groupNameTag.. "#schemaFixY");end;
	end;
	if loadCfg then
		if VehicleFruitHud.schemaPos > 1 or VehicleFruitHud.schemaZoom > 1.0 or VehicleFruitHud.schemaZoom < 1.0 then
			local tempHeight = 0;
			for key, value in pairs(g_currentMission.hud.vehicleSchema.vehicleSchemaOverlays) do
				tempHeight = (value.height*VehicleFruitHud.schemaZoom)-value.height
				value.height = value.height*VehicleFruitHud.schemaZoom;
				value.width = value.width*VehicleFruitHud.schemaZoom;
				if VehicleFruitHud.schemaPos == 1 then
					value.y = value.y+tempHeight; --default oben
				elseif VehicleFruitHud.schemaPos == 2 then
					g_currentMission.hud.vehicleSchema.overlay.y = 0.001+VehicleFruitHud.schemaFixY; --+(tempHeight/2);
					g_currentMission.hud.vehicleSchema.overlay.x = 0.98-g_currentMission.hud.vehicleSchema.maxSchemaWidth;			
				elseif VehicleFruitHud.schemaPos == 3 then
					g_currentMission.hud.vehicleSchema.overlay.x = 0.98-g_currentMission.hud.vehicleSchema.maxSchemaWidth;					
					for key, value in pairs(g_currentMission.hud.displayComponents) do
						if g_currentMission.hud.displayComponents[key].gaugeBackgroundElement ~= nil and g_currentMission.hud.displayComponents[key].gaugeCenterY ~= nil then
							g_currentMission.hud.vehicleSchema.overlay.y = g_currentMission.hud.displayComponents[key].gaugeCenterY+(g_currentMission.hud.displayComponents[key].gaugeBackgroundElement.overlay.height/1.5)+VehicleFruitHud.schemaFixY;
							break;
						end;
					end;
				end;
				--value.y = 0.025925925925926 --unten operatingTimeTextDrawPositionY
				--value.x = 0.96034617074377 --unten operatingTimeTextDrawPositionX
			end;	
		end;
	end;
end;

function VehicleFruitHud:getOptimalSize(width, txtString, defaultSize)
	local length = getTextWidth(defaultSize, tostring(txtString));
	local default = defaultSize;
	if length > width then
		local i = 0;
		while length > width do
			i = i + 0.0005;
			length = getTextWidth(defaultSize-i, tostring(txtString));
		end
		return defaultSize-i;
	end;
	return default;
end;